#include <unistd.h>
#include "operator.h"

int main(int argc,char **argv) {

  quBaseState qs(3,8); // bits=3, buflen=8

  quState *qbit;
  opBit H(1,1,1,-1,sqrt(0.5));

  state_map *qmap;
  bitvec v(3); // 3 bit vector

  for(int i=0; i<qs.mapbits(); i++) {
    qbit = qs.newsubstring(1,i);
    H.apply(*qbit);
    delete qbit;
  }
  qmap = qs.new_state_map(1e-6); // create map of qs with epsilon = 1e-6
  for (word i=0; i<8; ++i) {
    v.setbits(0,3,i);           // set v to i
    cout << "<" << v.getword() << "|qs>"; // could have just used "i"
    cout << " = " << (*qmap)[v] << "\n";
  }
}

